
#ifndef _Oz_Base_ManagerServer_ICE_
#define _Oz_Base_ManagerServer_ICE_

#include <Ice/Identity.ice>
#include <Domains/User.ice>
#include <Base/Session.ice>
#include <Base/Manager.ice>

module Oz
{
	module Base
	{
		class ServerManager;
		interface ManagerServerAdmin
		{
			idempotent ServerManager*
			createServerManager(
				Ice::Identity sessionId,
				Oz::Base::Session* sessionPx);

			idempotent void
			destroyServerManager(
				Ice::Identity sessionId);
				
			Object* 
			add(
				Object objectPt,
				Ice::Identity objectId);
				
			void
			remove(
				Ice::Identity objectId);
		};

		class ManagerServer
			implements ManagerServerAdmin
		{
			Ice::Identity id;
			ManagerMap managers;
		};
	};
};
#endif

