
#ifndef _Oz_Base_ServerManager_ICE_
#define _Oz_Base_ServerManager_ICE_

#include <Ice/ObjectAdapter.ice>
#include <Ice/Identity.ice>
#include <Base/OnRezServer.ice>
#include <Base/SearchManager.ice>
#include <Base/ManagerServer.ice>

module Oz
{
	module Base
	{
		interface ServerManagerAdmin
		{
			Oz::Base::Manager* createManager(Ice::Identity objectId);
			Oz::Base::Manager* getManager(Ice::Identity objectId);
			void destroyManager(Ice::Identity objectId);
			
			nonmutating ManagerServer* getManagerServer();
			idempotent void setManagerServer(ManagerServer* managerServerPx);
		};

		class ServerManager
			extends Oz::Searchs::SearchManager
			implements ServerManagerAdmin
		{
			ManagerServer* managerServerPx;
			int maxManagers;
			OnRezServer* serverPx;
			ManagerMap managers;
		};
	};
};
#endif

