
#ifndef _Oz_Domains_DomainManager_ICE_
#define _Oz_Domains_DomainManager_ICE_


#include <Base/Manager.ice>
#include <Ice/Identity.ice>
#include <DomainManager/UserManager.ice>
#include <DomainManager/GroupManager.ice>

module Oz
{
	module Domains
	{
		struct DomainInfo
		{
			Ice::Identity id;
			string name;
		};
		
		interface DomainManagerAdmin
		{
			GroupManager*
			createGroup(string name);
			
			UserManager*
			createUserAccount(string name,string mail,string password);

			UserManager*
			registerUserAccount(Ice::Identity registerId,string registerIp);

			bool
			login(string user,string password);
			
			nonmutating DomainInfo
			getDomainInfo();
			
			UserManager*
			getUserByLogin(string login);
		};

		class DomainManager 
			extends Oz::Base::Manager
			implements DomainManagerAdmin
		{
			Domain* domainPx;
		};
	};
};
#endif

