
#ifndef _Oz_Domains_UserManager_ICE_
#define _Oz_Domains_UserManager_ICE_

#include <Base/Manager.ice>
#include <Domains/User.ice>

module Oz
{
	module Domains
	{
		struct UserInfo
		{
			Ice::Identity id;
			string name;
			string mail;
			bool active;
			bool registered;
			string registerIp;
			Ice::Identity registerId;
		};
		
		interface UserManagerAdmin
		{
			void sendRegisterId();
			void sendNewPassword();
			void setPassword(string password);
			void setMail(string mail);
			void activate(bool active);
			UserInfo getUserInfo();
		};
		
		class UserManager 
			extends Oz::Base::Manager
			implements UserManagerAdmin
		{
			User* userPx;
		};
	};
};
#endif