
#ifndef _Oz_MetaService_MetaObjectManager_ICE_
#define _Oz_MetaService_MetaObjectManager_ICE_

#include <Base/Manager.ice>
#include <MetaService/MetaObject.ice>

module Oz
{
	module MetaService
	{
		struct MetaObjectInfo
		{
			Ice::Identity id;
			string metaType;
			Oz::Base::StringMap attributes;
		};
		dictionary<Ice::Identity,MetaObjectInfo>MetaObjectInfoMap;
		dictionary<string,MetaObjectInfo>MetaObjectInfoTypeMap;
		interface MetaObjectManagerAdmin
		{
			MetaObjectInfo getInfo();
			
			string getMetaType();
			string getAttributeNamed(string name);
			Oz::Base::StringMap getAttributes();
			
			void setAttribute(string name,string value);
			void setAttributes(Oz::Base::StringMap attributes);
		};
		
		class MetaObjectManager
			extends Oz::Base::Manager
			implements MetaObjectManagerAdmin
		{
			MetaObject* metaObjectPx;
		};
		
		dictionary<Ice::Identity,MetaObjectManager*>MetaObjectManagerMap;
	};
};
#endif