
#ifndef _Oz_MetaService_MetaManager_ICE_
#define _Oz_MetaService_MetaManager_ICE_

#include <Base/ServerManager.ice>
#include <Base/SysTypes.ice>
#include <MetaService/MetaObjectType.ice>
#include <MetaService/MetaAttributeType.ice>
#include <MetaManager/MetaObjectManager.ice>

module Oz
{
	module MetaService
	{
		interface MetaServerManagerAdmin
		{
			idempotent MetaObjectManager*
			createMetaObject(
				string type,
				Oz::Base::StringMap attributes);
				
			idempotent MetaObjectManager*
			getMetaObjectManager(
				Ice::Identity objectId);
				
			idempotent MetaObjectInfoMap
			getMetaObjectInfo(
				Oz::Base::Identities ids);

			idempotent MetaObjectInfo
			createMetaObjectType(
				string name,
				MetaAttributeTypeMap attributes);
				
			nonmutating MetaObjectInfoTypeMap
			listMetaTypes();
		};
	
		class MetaServerManager
			extends Oz::Base::ServerManager 
			implements MetaServerManagerAdmin
		{
		};
	};
};
#endif

