

#ifndef _Oz_Web_ApplicationManager_ICE_
#define _Oz_Web_ApplicationManager_ICE_

#include <Web/Request.ice>
#include <Web/Response.ice>
#include <Base/SessionManagerAdmin.ice>
#include <Web/StringResponseContent.ice>
#include <Web/FileResponseContent.ice>

module Oz
{
	module Web
	{
		/*
		 * Esta intenrface es la encargada de la comunicacion entre servidor web y aplicacion
		 */

		interface ApplicationManagerAdmin
		{
			void init();
			Response processRequest(Request rq);
		};
		
		interface ResponseContentManager
		{
			StringResponseContent* createStringResponseContent();
			FileResponseContent* createFileResponseContent();
			void destroyResponseContent(Ice::Identity id);
		};
		
		class ApplicationManager
			implements
				ApplicationManagerAdmin,
				Oz::Base::SessionManagerAdmin,
				ResponseContentManager
		{
			Ice::Identity id;
			
			string domainName;
			string virtualHost;
			string xslTemplateDir;
		};
	};
};
#endif

