
#ifndef _Oz_Web_Request_ICE_
#define _Oz_Web_Request_ICE_

#include <Base/SysTypes.ice>
#include <Web/Cookie.ice>

module Oz
{
	module Web
	{
		/**
		 * Este componente emcapsula el objeto Request del protocolo HTTP
		 *
		 */

		struct FileInfo
		{
			string filename;
			string clientFilename;
			string contentType;
		};
		
		dictionary <string,FileInfo> FileInfoMap;
		
		interface RequestAdmin
		{
			void addHeader(string name,string value);
			string getHeader(string name);
			Oz::Base::StringMap getHeaders();

			void addQueryVar(string name,string value);
			string getQueryVar(string name);
			Oz::Base::StringMap getQueryVars();

			void addFile(FileInfo file);
			FileInfo getFile(string fileName);
			FileInfoMap getFiles();

			void setUri(string uri);
			string getUri();

			void setSessionId(string sessionId);
			string getSessionId();
		};
		
		class Request
			implements RequestAdmin
		{
			Oz::Base::StringMap headers;
			Oz::Base::StringMap queryVars;
			Oz::Web::FileInfoMap files;
			string uri;
			string sessionId;
		};
	};
};
#endif


