
#ifndef _Oz_Web_Response_ICE_
#define _Oz_Web_Response_ICE_

#include <Base/SysTypes.ice>
#include <Web/ResponseContent.ice>
#include <Web/Cookie.ice>

module Oz
{
	module Web
	{
		/**
		 * Este componente emcapsula el objeto Response usado en le protocolo HTTP
		 *
		 */
		interface ResponseAdmin
		{
			void 
			setContent(
				ResponseContent* content);
			
			ResponseContent*
			getContent();
			
			string
			getContentType();
			
			string 
			getHeader(
				string name);
			void addHeader(string name,string value);
			
			Oz::Base::StringMap
			getHeaders();
			
			void
			setHeaders(Oz::Base::StringMap headers);

			void
			addCookie(Cookie c);
			
			CookieMap getCookies();
			Cookie getCookie(string id);
			
			void
			destroy();
		};

		class Response
			implements ResponseAdmin
		{
			ResponseContent* responseContentPx;
			CookieMap cookies;
			Oz::Base::StringMap headers;
		};
	};
};

#endif

