
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Base_AclAdmin_ICE_
#define _Oz_Base_AclAdmin_ICE_

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_OZ_BASE_SYSTYPES
#define INCLUDE_OZ_BASE_SYSTYPES
	#include <Base/SysTypes.ice>
#endif


module Oz
{
	module Base
	{
		/**
		 * Esta interface define el conjuto de acciones para la
		 * administracion de Acls.
		 */

		interface AclAdmin
		{
		
			/**
			 * Aade una entidad a la lista de entidades que pueden
			 * ejecutar determinado metodo.
			 *
			 * @param string method nombre del metodo al que se aade permiso
			 * @param Ice::Identity id del usuario al que se conceden permisos
			 */

			idempotent void
			addEntity(
				string method,
				Ice::Identity usuario);
			
			/**
			 * Elimina una entidad de la lista de entidades que pueden ejecutar
			 * un metodo.
			 *
			 * @param string
			*/
			
			idempotent void 
			delEntity(
				string method,
				Ice::Identity usuario);
				
			nonmutating Identities 
			getEntities(
				string method);
				
			nonmutating Ice::Identity 
			getOwmner();
			
			idempotent void 
			chown(
				Ice::Identity usuario);
			
			nonmutating bool 
			auth(string roll,Identities entities);
			
			
			idempotent void 
			addRoll(string roll);
			
			idempotent void 
			delRoll(string roll);
			
			nonmutating Strings 
			getRolls();
		};
	};
};
#endif

