
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Base_Chunk_ICE_
#define _Oz_Base_Chunk_ICE_

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

module Oz
{
	module Base
	{
		sequence<byte> Bytes;
		sequence<long> ChunkRefs;
		
		interface ChunkWriter 
		{
			idempotent bool 
			write(
				long pos,
				Bytes content);
		};

		interface ChunkReader
		{
			nonmutating Bytes 
			read();
		};

		/**
		 * Esta clase representa un trozo de un fichero
		 */
		 
		class Chunk implements ChunkWriter,ChunkReader
		{
			Ice::Identity id;
			long pos;
			Bytes content;
		};
	
		dictionary<long,Chunk*> ChunksMap;
		dictionary<long,Chunk> ChunksPtMap;
	};
};
#endif

