
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Base_Date_ICE_
#define _Oz_Base_Date_ICE_

module Oz
{
	module Base
	{
		interface DateAdmin
		{
			idempotent bool 
			setDate(
				int year,
				int month,
				int day);
				
			idempotent bool 
			setYear(
				int year);
			
			idempotent bool 
			setMonth(
				int month);
			
			idempotent bool 
			setDay(
				int day);
	
			idempotent bool 
			setTime(
				int hour,
				int min,
				int sec);
				
			idempotent bool 
			setHour(
				int hour);
			
			idempotent bool 
			setMin(
				int min);
			
			idempotent bool 
			setSec(
				int sec);

			nonmutating string 
			getDate();
			
			nonmutating string 
			getTime();
			
			nonmutating int 
			getDay();
			
			nonmutating int 
			getMonth();
			
			nonmutating int 
			getYear();
	
			nonmutating int 
			getHour();
			
			nonmutating int 
			getMin();
			
			nonmutating int 
			getSec();
	
			nonmutating string 
			getXmlDescription();

			nonmutating long
			getUnixTime();
		};
		
		/**
		 * Representa una fecha
		 */
		
		class Date implements DateAdmin
		{
			long unixTime;
			int year;
			int month;
			int day;
	
			int hour;
			int minute;
			int sec;
		};
	};
};
#endif

