
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Base_OnRez_ICE_
#define _Oz_Base_OnRez_ICE_

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ACL
#define INCLUDE_OZ_BASE_ACL
	#include <Base/Acl.ice>
#endif


	#include <Base/AclAdmin.ice>


#ifndef INCLUDE_OZ_BASE_ONREZADMIN
#define INCLUDE_OZ_BASE_ONREZADMIN
	#include <Base/OnRezAdmin.ice>
#endif

#ifndef INCLUDE_OZ_BASE_INDEXABLE
#define INCLUDE_OZ_BASE_INDEXABLE
	#include <Base/Indexable.ice>
#endif


module Oz
{
    module Base
    {

	/**
	* Clase que aporta una serie de funcionalidades comunes a los obetos de negocio,
	* gestion de acessos, sistema eventos, sistema comentarios.
	*
	**/

        class OnRez 
			implements AclAdmin,
				OnRezAdmin,
				Indexable
		{
			/**
			*Proxy que referencia a si mismo
			**/
			OnRez* myPx;
			
			/**
			 * Proxy al servicio en el cual se creo el objeto
			 */
			OnRezServer* service;
			
			/**
			 * Id unico que identifica un objeto en el sistema
			**/
			Ice::Identity id;
			
			/**
			 * Proxy al objeto Acl (Control de listas de accesos) asignado a este
			 * objeto.
			*/
			Acl* aclPx;
		};

		/**
		* Definicion de un diccionario generico de objetos OnRez
		**/
		dictionary<Ice::Identity,OnRez*> ObjectIdMap;
	};
};
#endif
