
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Base_OnRezServer_ICE_
#define _Oz_Base_OnRezServer_ICE_

#include <Freeze/Evictor.ice>
#include <Ice/ObjectAdapter.ice>
#include <Base/OnRez.ice>
#include <Base/Acl.ice>
#include <Base/AclAdmin.ice>
#include <Base/AclServer.ice>
#include <Searchs/SearchServer.ice>
#include <Searchs/Indexer.ice>
#include <Searchs/Searcher.ice>

module Oz
{
	module Base
	{
		interface ServiceAdmin
		{
			nonmutating bool
			hasObject(
				Ice::Identity id);
			
			idempotent Object*
			add(
				Object obj,
				Ice::Identity id);
				
			nonmutating Object*
			get(
				Ice::Identity id);
			
			idempotent void
			remove(
				Ice::Identity id);
				
			idempotent void
			setModelServer(OnRezServer* server);
		};
		
		
		/**
		 * Servicio basico de objetos negocio, provee una serie de funcionalidades
		 * comunes a los distintos servicios de objetos del sistema. Incluye gestion
		 * de seguridad (ACLS) y persistencia de objetos.
		 */
		
		class OnRezServer 
			implements 
				AclServerAdmin,
				ServiceAdmin,
				Oz::Searchs::SearcherAdmin,
				Oz::Searchs::IndexerAdmin
		{
		};
	};
};
#endif

