
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Domains_Domain_ICE_
#define _Oz_Domains_Domain_ICE_

//Oz includes

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_DOMAINS_USER
#define INCLUDE_OZ_DOMAINS_USER
	#include <Domains/User.ice>
#endif

#ifndef INCLUDE_OZ_DOMAINS_GROUP
#define INCLUDE_OZ_DOMAINS_GROUP	
	#include <Domains/Group.ice>
#endif

module Oz
{
	module Domains
	{
		interface DomainClient
		{
			idempotent User* login(string name,string passwd);
		};
	
		interface DomainAdmin
		{
			nonmutating string 
			getName();
	
			idempotent User* 
			createUser(
				string name,
				string passwd,
				string mail);
				
			idempotent User*
			registerAccount(
				Ice::Identity activationId,
				string activationIp);
			
			
			idempotent bool 
			deleteUser(
				Ice::Identity userId);


			idempotent Group* 
			createGroup(
				string name);
			
			idempotent bool 
			deleteGroup(
				Ice::Identity groupId);
				
				
			nonmutating User*
			getUser(string name);
			
			nonmutating User*
			getUserById(
				Ice::Identity userId);
			
			nonmutating Group*
			getGroup(
				string name);
			
			nonmutating Group*
			getGroupById(
				Ice::Identity groupId);
		};
		
		class Domain 
			extends 
				Oz::Base::OnRez 
			implements 
				DomainAdmin,
				DomainClient
		{
				string domainName;
		};
	};
};
#endif

