
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Domains_Group_ICE_
#define _Oz_Domains_Group_ICE_

//Oz includes

#ifndef INCLUDE_OZ_BASE_ENTIDAD
#define INCLUDE_OZ_BASE_ENTIDAD
	#include <Base/Entidad.ice>
#endif

#ifndef INCLUDE_OZ_FILES_FILE
#define INCLUDE_OZ_FILES_FILE
	#include <Files/File.ice>
#endif

module Oz
{
	module Domains
	{
		class Domain;

		interface GroupAdmin
		{
			idempotent void 
			addUser(
				Ice::Identity id);

			nonmutating bool
			hasUser(
				Ice::Identity userId);
			
			idempotent void 
			delUser(
				Ice::Identity id);
	
			nonmutating Oz::Domains::Domain*
			getDomain();
	
			idempotent bool 
			setDomain(
				Oz::Domains::Domain* dominio);
		};
		
		class Group 
			extends 
				Oz::Base::Entidad 
			implements 
				GroupAdmin
		{
			Oz::Domains::Domain* dominio;
		};
		
		dictionary<Ice::Identity,Group*> GroupsMap;
	};
};
#endif

