
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Domains_User_ICE_
#define _Oz_Domains_User_ICE_

#include <Ice/Identity.ice>
#include <Base/Entidad.ice>
#include <Files/File.ice>
#include <Base/Date.ice>

module Oz
{
	module Domains
	{
		class Domain;
		
		interface SystemLogin
		{
			nonmutating bool 
			login(
				string passwd);
		};
		
		
		interface UserAdmin
		{
			idempotent bool 
			addGroup(
				Ice::Identity group);
			
			idempotent bool 
			delGroup(
				Ice::Identity group);
			
			nonmutating Oz::Base::Identities 
			getGroups();
			
			idempotent bool 
			setPasswd(
				string passwd);
			
			idempotent bool 
			setMail(
				string mail);
			
			nonmutating string 
			getPasswd();
			
			nonmutating string 
			getMail();
			
			nonmutating bool 
			isActived();
			
			nonmutating Oz::Domains::Domain*
			getDomain();
			
			idempotent bool 
			setDomain(
				Oz::Domains::Domain* dominio);
			
			idempotent bool 
			setActived(
				bool actived);
				
			nonmutating Oz::Base::Date
			getCreationDate();
			
			nonmutating Oz::Base::Date
			getRegisterDate();
			
			nonmutating string
			getRegisterIp();
			
			nonmutating Ice::Identity
			getRegisterId();
			
			nonmutating bool
			isRegister();
			
			idempotent void
			registerAccount(
				Ice::Identity registerId,
				string registerIp);
		};

		class User 
			extends 
				Oz::Base::Entidad  
			implements 
				UserAdmin,
				SystemLogin
		{
			
			Oz::Base::Date creationDate;
			
			/**
			 * datos asociados al registro 
			 * de este usuario
			 */
			Ice::Identity registerId;
			Oz::Base::Date registerDate;
			string registerIp;
			
			Domain* dominio;
			string passwd;
			string mail;
			Oz::Base::Identities groups;
			
			bool registered;
			bool active;
		};

		dictionary<Ice::Identity,User*> UsersMap;
	};
};
#endif

