
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Files_File_ICE_
#define _Oz_Files_File_ICE_

#include <Ice/Identity.ice>
#include <Base/OnRez.ice>
#include <Base/Chunk.ice>
#include <Files/Node.ice>

module Oz
{
	module Files
	{
		class File;

		interface FileReader
		{
			nonmutating Oz::Base::ChunksMap 
			read();
			
			nonmutating long 
			countChunks();
			
			nonmutating int 
			getChunkSize();
			
			nonmutating long 
			getSize();
			
			nonmutating Oz::Base::Chunk* 
			readChunk(
				long id);
		};

		interface FileWriter
		{
			idempotent bool writeChunk(
				Oz::Base::Bytes content);

			idempotent bool addChunk(
				Oz::Base::Chunk source);
		};

		class File 
			extends 
				Node 
			implements 
				FileReader,
				FileWriter
		{
			int chunkSize;
			Oz::Base::ChunksMap content;
		};
	};
};
#endif

