
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Files_Node_ICE_
#define _Oz_Files_Node_ICE_


#include <Base/AclAdmin.ice>
#include <Base/OnRez.ice>
#include <Base/Date.ice>

module Oz
{
	module Files
	{
		class Node;
		class FileSystem;
		
		interface NodeReader
		{
			nonmutating string 
			getName();
			
			nonmutating Node* 
			getParent();
			
			nonmutating Node*
			getNode(string path);

			nonmutating string 
			getPath();
			
			nonmutating string 
			getContentType();
			
			nonmutating string 
			getExtension();

			nonmutating Oz::Base::Date
			getCreationDate();

			nonmutating Oz::Base::Date
			getUpdateDate();
			
			nonmutating bool
			hasNode(string path);
		};
		
		interface NodeWriter
		{
			idempotent void
			setName(
				string name);
			
			idempotent void 
			setParent(
				Node* parent);
			
			idempotent void 
			setContentType(
				string contentType);
			
			idempotent void 
			setExtension(
				string extension);

			nonmutating bool
			isHidden();

			idempotent void
			setHidden(bool hidden);

			idempotent void
			setFileSystem(
				FileSystem* fileSys,
				string fileSystemName);

			nonmutating FileSystem*
			getFileSystem();
		};
		
		
		/**
		 * Representa un elemento en el servicio de ficheros
		 */

		class Node 
			extends 
				Oz::Base::OnRez 
			implements 
				NodeReader,
				NodeWriter
		{
			int pos;
			bool hidden;
			Oz::Base::Date creationDate;
			Oz::Base::Date updateDate;
			int lectures;
			FileSystem* fileSystemPx;
			string fileSystemName;
			Node* parent;
			string name;
			string contentType;
			string extension;
		};
		
		["java:type:java.util.TreeMap"]
			dictionary<string,Node*> StringNodeMap;
		["java:type:java.util.TreeMap"]
			dictionary<int,Node*> IntNodeMap;
	};
};
#endif

