
#ifndef _Oz_MetaService_MetaAttributeType_ICE_
#define _Oz_MetaService_MetaAttributeType_ICE_

module Oz
{
	module MetaService
	{
		/**
		 * Este atributo permite definir como el motor de busquedas
		 * tratara un attributo concreto de un meta objeto
		 * Stored (attributos que el motor de busquedas almacena)
		 * Indexed (attributos indexados por el motor)
		 * None (estos attributos son ignorados por el motro de busquedas)
		 */

		enum IndexType{Stored,Indexed,None};
		
		/**
		 * Esta clase permite definir tipos de attributos
		 */
		 
		interface MetaAttributeTypeAdmin
		{
			nonmutating string getName();
			nonmutating IndexType getIndexType();
		};

		class MetaAttributeType
			implements MetaAttributeTypeAdmin
		{
			string name;
			IndexType indexKeyword;
		};
		
		dictionary<string,MetaAttributeType> MetaAttributeTypeMap;
	};
};
#endif
