

#ifndef _Oz_MetaService_MetaObject_ICE_
#define _Oz_MetaService_MetaObject_ICE_

#include <Base/SysTypes.ice>
#include <Base/OnRez.ice>
#include <Base/Date.ice>
#include <MetaService/MetaObjectType.ice>


module Oz
{
	module MetaService
	{	
		interface MetaObjectAdmin
		{
			nonmutating MetaObjectType* getType();
			idempotent void setAttribute(string name,string value);
			nonmutating bool hasAttribute(string name);
			nonmutating string getAttribute(string name);
			nonmutating Oz::Base::StringMap getAttributes();
			idempotent void delAttribute(string name);
			idempotent void clear();
			
			nonmutating Oz::Base::Date getCreationDate();
			nonmutating Oz::Base::Date getUpdateDate();
		};
		
		class MetaObject
			extends Oz::Base::OnRez
			implements MetaObjectAdmin
		{
			Oz::Base::Date creationDate;
			Oz::Base::Date updateDate;
			MetaObjectType* type;
			Oz::Base::StringMap attributes;
		};
		sequence<MetaObject>MetaObjectList;
	};
};
#endif
