
#ifndef _Oz_Searchs_LuceneServer_ICE_
#define _Oz_Searchs_LuceneServer_ICE_

#include <Searchs/Indexer.ice>
#include <Searchs/Searcher.ice>

module Oz
{
	module Searchs
	{
		interface LuceneServerAdmin
		{
			/**
			 * Inicializa la base de datos Lucene
			 */
			 
			void createDB(string indexDir);
			/**
			* returns a proxy to Indexer servant for 
			* given indexDir. there are only one servant
			* for each indexDir
			*/

			Indexer* getIndexer(string indexDir);
			
			/**
			* returns a proxy to Searcher servant for 
			* given indexDir. there are only one servant
			* for each indexDir
			*/

			Searcher* getSearcher(string indexDir);
		};
		
		/**
		 * This servant implements and api 
		 * to access Lucene Indexer/Searcher objets
		 * Object is registred with id LuceneServer/LuceneServer
		 *
		 */

		class LuceneServer implements LuceneServerAdmin
		{
			["java:type:java.util.TreeMap"]SearcherMap searchers;
			["java:type:java.util.TreeMap"]IndexerMap indexers;
		};
	};
};
#endif