// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.0.1
// Generated from file `SessionManagerAdmin.ice'

#ifndef __Base_SessionManagerAdmin_h__
#define __Base_SessionManagerAdmin_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/StreamF.h>
#include <Ice/Identity.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 300
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ONREZ_API
#   ifdef ONREZ_API_EXPORTS
#       define ONREZ_API ICE_DECLSPEC_EXPORT
#   else
#       define ONREZ_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace Oz
{

namespace Base
{

class SessionManagerAdmin;
ONREZ_API bool operator==(const SessionManagerAdmin&, const SessionManagerAdmin&);
ONREZ_API bool operator!=(const SessionManagerAdmin&, const SessionManagerAdmin&);
ONREZ_API bool operator<(const SessionManagerAdmin&, const SessionManagerAdmin&);

}

}

}

namespace Oz
{

namespace Base
{

class SessionManagerAdmin;
ONREZ_API bool operator==(const SessionManagerAdmin&, const SessionManagerAdmin&);
ONREZ_API bool operator!=(const SessionManagerAdmin&, const SessionManagerAdmin&);
ONREZ_API bool operator<(const SessionManagerAdmin&, const SessionManagerAdmin&);

}

}

namespace IceInternal
{

ONREZ_API void incRef(::Oz::Base::SessionManagerAdmin*);
ONREZ_API void decRef(::Oz::Base::SessionManagerAdmin*);

ONREZ_API void incRef(::IceProxy::Oz::Base::SessionManagerAdmin*);
ONREZ_API void decRef(::IceProxy::Oz::Base::SessionManagerAdmin*);

}

namespace Oz
{

namespace Base
{

typedef ::IceInternal::Handle< ::Oz::Base::SessionManagerAdmin> SessionManagerAdminPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Oz::Base::SessionManagerAdmin> SessionManagerAdminPrx;

ONREZ_API void __write(::IceInternal::BasicStream*, const SessionManagerAdminPrx&);
ONREZ_API void __read(::IceInternal::BasicStream*, SessionManagerAdminPrx&);
ONREZ_API void __write(::IceInternal::BasicStream*, const SessionManagerAdminPtr&);
ONREZ_API void __patch__SessionManagerAdminPtr(void*, ::Ice::ObjectPtr&);

}

}

namespace Oz
{

namespace Base
{

}

}

namespace IceProxy
{

namespace Oz
{

namespace Base
{

class ONREZ_API SessionManagerAdmin : virtual public ::IceProxy::Ice::Object
{
public:

    void destroySession(const ::Ice::Identity&);
    void destroySession(const ::Ice::Identity&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

}

namespace IceDelegate
{

namespace Oz
{

namespace Base
{

class ONREZ_API SessionManagerAdmin : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void destroySession(const ::Ice::Identity&, const ::Ice::Context&) = 0;
};

}

}

}

namespace IceDelegateM
{

namespace Oz
{

namespace Base
{

class ONREZ_API SessionManagerAdmin : virtual public ::IceDelegate::Oz::Base::SessionManagerAdmin,
				      virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void destroySession(const ::Ice::Identity&, const ::Ice::Context&);
};

}

}

}

namespace IceDelegateD
{

namespace Oz
{

namespace Base
{

class ONREZ_API SessionManagerAdmin : virtual public ::IceDelegate::Oz::Base::SessionManagerAdmin,
				      virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void destroySession(const ::Ice::Identity&, const ::Ice::Context&);
};

}

}

}

namespace Oz
{

namespace Base
{

class ONREZ_API SessionManagerAdmin : virtual public ::Ice::Object
{
public:

    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void destroySession(const ::Ice::Identity&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___destroySession(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ONREZ_API __patch__SessionManagerAdminPtr(void*, ::Ice::ObjectPtr&);

}

}

#endif
